<?php
@header('Content-type: text/html; charset=utf-8');

function get_api($apiurl, $apikey, $secret, $para) {
	$para['apikey'] = $apikey;
	$para['timestamp'] = time();
	
	ksort($para);

	$sign = $secret;
	foreach($para as $key => $val) {
		$sign .= $key.$val;
	}
	$sign .= $secret;

	$para['sign'] = md5($sign);
	
	$delimiter = (strpos($apiurl, '?') === false) ? '?' : '&';
	$url = $apiurl.$delimiter.http_build_query($para);

	$content = curl_http_request($url, $para, 'GET');

	if ($content == false)
		return false;

	return json_decode($content, true);
}

function socket_http_request($url, $post_data) {
	$options = array(
		'http' => array(
			'method' => 'POST',
			'header' => 'Content-type:application/x-www-form-urlencoded',
			'timeout' => 900
		)
	);
	$context = stream_context_create($options);
	$result = file_get_contents($url, false, $context);

	return $result;
}

function curl_http_request($url, $param, $http_method = 'POST') {
	$connect_timeout = 2000;
	$read_timeout = 3000;
	$timeout = $connect_timeout + $read_timeout;
	$user_agent = sprintf('Open API');

	$ch = curl_init();
	$curl_opts = array( CURLOPT_USERAGENT => $user_agent,
						CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
						CURLOPT_RETURNTRANSFER => true,
						CURLOPT_HEADER => false,
						CURLOPT_FOLLOWLOCATION => false,
						CURLOPT_SSL_VERIFYPEER => false,
						);
	if (defined('CURLOPT_CONNECTTIMEOUT_MS')) {
		$curl_opts[CURLOPT_CONNECTTIMEOUT_MS] = $connect_timeout;
		$curl_opts[CURLOPT_TIMEOUT_MS] = $timeout;
	} 
	else {
		$curl_opts[CURLOPT_CONNECTTIMEOUT] = ceil($connect_timeout/1000);
		$curl_opts[CURLOPT_TIMEOUT] = ceil($timeout/1000);
	}
	
	if ($http_method == 'POST') {
		$curl_opts[CURLOPT_URL] = $url;
		$curl_opts[CURLOPT_POSTFIELDS] = $param;
		$curl_opts[CURLOPT_POST] = true;
	} 
	else {
		$delimiter = (strpos($url, '?') === false) ? '?' : '&';
		$curl_opts[CURLOPT_URL] = $url.$delimiter.http_build_query($param);
		$curl_opts[CURLOPT_POST] = false;
	}

	curl_setopt_array($ch, $curl_opts);

	$result = curl_exec($ch);
	if ($result === false) {
		$error = curl_error($ch);
	}
	
	curl_close($ch);

	return $result;
}

$api_url = 'http://localhost/openapi.php';   //Webmail URL
$api_key = '123aaaa9d4b';	//OpenAPI appKey
$api_secret = '111222f8f6871a8djjerjr35199b98888'; 	//OpenAPI appSecret

//û¼
$para = array();
$para['method'] = 'login';
$para['user'] = 'steven@cnu.com';
$para['pass'] = 'usrpwd';

$loginuser = get_api($api_url, $api_key, $api_secret, $para);
var_dump($loginuser);
echo '<br>';
if (is_array($loginuser) && $loginuser['result'] == 'ok') {
	//ȡռʼ
	$para = array();
	$para['method'] = 'msglist';
	$para['sessid'] = $loginuser['info']['sessid'];
	$para['folder'] = 'INBOX';

	$res = get_api($api_url, $api_key, $api_secret, $para);

	var_dump($res);
	echo '<br>';

	//ȡļб
	$para = array();
	$para['method'] = 'folders';
	$para['sessid'] = $loginuser['info']['sessid'];

	$res = get_api($api_url, $api_key, $api_secret, $para);

	var_dump($res);
	echo '<br>';
	
	//ļʼ
	$para = array();
	$para['method'] = 'msgnum';
	$para['sessid'] = $loginuser['info']['sessid'];

	$res = get_api($api_url, $api_key, $api_secret, $para);

	var_dump($res);
	echo '<br>';
	
	//ϵ
	$para = array();
	$para['method'] = 'addressbook.addcontact';
	$para['sessid'] = $loginuser['info']['sessid'];
	$para['name'] = 'winmail support';
	$para['email'] = 'support@magicwinmail.com';

	$res = get_api($api_url, $api_key, $api_secret, $para);

	var_dump($res);
	echo '<br>';
	
}


?>